'use strict';

var RelatorioFotograficoController = angular.module('RelatorioFotograficoController', []);

RelatorioFotograficoController.controller('RelatorioFotograficoCtrl', ['$scope', '$filter', 'Relatorio', 'CacheApp',
  ($scope, $filter, Relatorio, CacheApp) => {
      $scope.construcao = CacheApp.getConstrucao();

      $scope.assinatura = true;
      $scope.descricaoObra = true;

      $scope.relatorio = {};
      $scope.relatorio.DataInicio = CacheApp.getData($scope.construcao.DataInicio ? $filter("date")($scope.construcao.DataInicio, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
      $scope.relatorio.DataFim = CacheApp.getData($scope.construcao.DataFim ? $filter("date")($scope.construcao.DataFim, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));

      $scope.getRelatorioFotografico = () => {
          $scope.etapas = [];
          Relatorio.getRelatorioFotografico($scope.construcao.Id, $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'), $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'),
              (data) => {
                  $scope.etapas = data.Instance;
                  for (var i in $scope.etapas)
                    for (var j in $scope.etapas[i].Imagens) {
                      var dataHora = CacheApp.getData($filter("date")($scope.etapas[i].Imagens[j].Data, 'yyyy-MM-ddT00:00:00Z'));
                      $scope.etapas[i].Imagens[j].Data = new Date(dataHora.getTime() + (24 * (60 * 60 * 1000)));
                    }
              });
      }
      $scope.getRelatorioFotografico();

      $scope.pdfRelatorioFotografico = () => {
          var cabecalho = {
              Avatar: $scope.construcao.ContaAvatar,
              Obra: $scope.construcao.Titulo,
              Conta: $scope.construcao.Conta,
              DataInicio: $filter("date")($scope.relatorio.DataInicio, 'dd/MM/yyyy'),
              DataFim: $filter("date")($scope.relatorio.DataFim, 'dd/MM/yyyy')
          };

          if ($scope.assinatura == true) {
            cabecalho.Responsavel = $scope.construcao.Contato
          };
          if ($scope.descricaoObra == true) {
                cabecalho.DescricaoObra = $scope.construcao.Descricao
          };

          Relatorio.pdfRelatorioFotografico($scope.construcao.Id, $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'), $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'), cabecalho,
              (data) => {
                  window.location.assign(data.Instance);
              });
      }
  }]);
